
//	Copyright 2011 PaletteSoft LLC

//	*     *   ***   ******* *     *                                           
//	**   **  *   *     *    **    *                                           
//	* * * * *     *    *    * *   *                                           
//	*  *  * *     *    *    *  *  *                                           
//	*     * *******    *    *   * *                                           
//	*     * *     *    *    *    **                                           
//	*     * *     * ******* *     *                                           

// ===========================================================================
// =	CL^															 =
// ===========================================================================
//	002 2011.??.??
//	E
// ---------------------------------------------------------------------------
//	001 2011.08.09
//	EVK쐬		HI-TECH C Ver9.81ȍ~
// ===========================================================================

#define	SYSTEM_NAME				"10 POINT RGB LED ARRAY SAMPLE 2"		//	VXe
#define	COPYRIGHT				"Copyright 2011 PaletteSoft LLC"		//	쌠

// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************

	//	*****  *****

	

	//	***** 錾 *****

#include	"_AtrDef.h"													//	萔Af[^^̐錾i̒ _AtrMpu.h, htc.h 荞ށj
#include	"version.h"													//	o[Wԍ̒`

	//	*****  *****

#include	"DrvSw.h"													//	XCb`Cu

// ***************************************************************************
// *	dl															 *
// ***************************************************************************
/*
	PO|Cg@qfa@kdcAC@TvvO@̂P

	CPU		: PIC16F886 or PIC16F1938
	VCC		: 5.0V
	CLOCK	: INTOSC/8MHz
	DEVICE	: OSX10201-LRPB2(10 POINT RGB LED ARRAY)

	PORT	FUNC		@\		ڑ					ݒ
	--------------------------------------------------------------------------
	RA0		RA0			LED-a		kdcAC`i[j	o͂k
	RA1		RA1			LED-b		kdcACa			o͂k
	RA2		RA2			LED-c		kdcACb			o͂k
	RA3		RA3			LED-d		kdcACc			o͂k
	RA4		RA4			SW			XCb`				́AOvAbv
	RA5		RA5			-----								o͂k
	RA6		RA6			-----								o͂k
	RA7		RA7			-----								o͂k

	RB0		RB0			LED-e		kdcACd			o͂k
	RB1		RB1			LED-f		kdcACe			o͂k
	RB2		RB2			LED-g		kdcACf			o͂k
	RB3		RB3			LED-h		kdcACg			o͂k
	RB4		RB4			LED-i		kdcACh			o͂k
	RB5		RB5			LED-j		kdcACiiE[j	o͂k
	RB6		ICSPCLK		\								́AvAbv
	RB7		ICSPDAT		\								́AvAbv

	RC0		RC0			-----								o͂k
	RC1		RC1			LED-G-K		kdcAC΃J\[h	o͂g
	RC2		RC2			LED-B-K		kdcACJ\[h	o͂g
	RC3		RC3			LED-R-K		kdcACԃJ\[h	o͂g
	RC4		RC4			-----								o͂k
	RC5		RC5			-----								o͂k
	RC6		RC6			-----		ʐMpɗ\ATXD		́AOvAbv
	RC7		RC7			-----		ʐMpɗ\ARXD		́AOvAbv

	RE3		_MCLR		\								\iWeekPullUpj

	--------------------------------------------------------------------------
	ɊւoF

	Ekdc̓AC̈ʒui``ijɑ΂ē_֎~B
	ECӂ̏ꏊgőIAIFɑΉ|[gkɂƓ_B
	Eꏊړꍇ͌ݓ_̏ԂĂړB
*/

// ***************************************************************************
// *																 *
// ***************************************************************************

	//	***** iPIC16F886j *****								//	ӁF16F886̗lCONFIGQAꍇ͂Qu__CONFIGv`鎖

#ifdef __PIC16F886_H
__CONFIG(	LVP_OFF														//	qaR͓o͂ŗp
		&	FCMEN_OFF													//	tF[Z[tNbNj^͗pȂ
		&	IESO_OFF													//	OXCb`I[o[͗pȂ
		&	BOREN_OFF													//	uEAEg͗pȂ
		&	CPD_OFF														//	f[^iEEPROMj̃veNg͍sȂ
		&	CP_OFF														//	vÕveNg͍sȂ
		&	MCLRE_ON													//	lbkq𗘗piRE3͓o͂ŗpłȂj@vAbv
		&	PWRTE_ON													//	p[Abv^C}싖
		&	WDTE_OFF													//	EHb`hbO^C}֎~
		&	FOSC_INTRC_NOCLKOUT											//	NbNœ삵ARA6RA7͓o͂ŗp
);
__CONFIG(	BOR4V_BOR40V												//	uEAEg͂SDOuigpj
		&	WRT_OFF														//	݃veNg
);
#endif

	//	***** iPIC16F1938j *****

#ifdef	__PIC16F1938_H
/*	X҂
__CONFIG(	
};
__CONFIG(	
};
*/
#endif

	//	***** hc *****

__IDLOC7(VER1, VER2, VER3, VER4);										//	o[WԍƂĒ`ïӖt͔CӁj

	//	***** U *****

#define	_XTAL_FREQ				8000000									//	giNbNpj

// ***************************************************************************
// *	Œl																 *
// ***************************************************************************

	//	***** kdcp̃|[g}XNf[^ *****
//								  76543210
#define	LED_PORT_MASK_A			0b00001111								//	|[g`}XNf[^
#define	LED_PORT_MASK_B			0b00111111								//	|[ga}XNf[^
#define	LED_PORT_MASK_C			0b00001110								//	|[gb}XNf[^

	//	***** kdc̊{F *****
//								  76543210
#define	LED_BASE_OFF			0b11111111								//	Skdc
#define	LED_BASE_R				0b11110111								//	Ԃkdc_i{Fj
#define	LED_BASE_B				0b11111011								//	kdc_i{Fj
#define	LED_BASE_G				0b11111101								//	΂kdc_i{Fj

	//	***** kdc̔FwifoCXˑj *****

#define	LED_DEV_BLACK			(LED_BASE_OFF)							//	F
#define	LED_DEV_RED				(LED_BASE_R							 )	//	ԐF
#define	LED_DEV_BLUE			(			  LED_BASE_B			 )	//	F
#define	LED_DEV_PURPLE			(LED_BASE_R & LED_BASE_B			 )	//	F
#define	LED_DEV_GREEN			(						   LED_BASE_G)	//	ΐF
#define	LED_DEV_YELLOW			(LED_BASE_R & 			   LED_BASE_G)	//	F
#define	LED_DEV_WATER			(			  LED_BASE_B & LED_BASE_G)	//	FipłLightBluecȂ̂ŋɁuvŌ떂܂j
#define	LED_DEV_WHITE			(LED_BASE_R & LED_BASE_B & LED_BASE_G)	//	F

	//	***** kdc̈ʒuwifoCXˑj *****

#define	LED_DEV_A				((UH)BIT00)								//	[	*.........	
#define	LED_DEV_B				((UH)BIT01)								//			.*........	
#define	LED_DEV_C				((UH)BIT02)								//			..*.......	
#define	LED_DEV_D				((UH)BIT03)								//			...*......	
#define	LED_DEV_E				((UH)BIT04)								//			....*.....	
#define	LED_DEV_F				((UH)BIT05)								//			.....*....	
#define	LED_DEV_G				((UH)BIT06)								//			......*...	
#define	LED_DEV_H				((UH)BIT07)								//			.......*..	
#define	LED_DEV_I				((UH)BIT08)								//			........*.	
#define	LED_DEV_J				((UH)BIT09)								//	E[	.........*	

// ***************************************************************************
// *	\̃ev[g													 *
// ***************************************************************************


// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************

	//	***** |[g *****												//	k`sWX^gȂ@͗p܂

_UB		vDevPortA;														//	|[g`̃obNAbv
_UB		vDevPortB;														//	|[gãobNAbv
_UB		vDevPortC;														//	|[gb̃obNAbv

	//	***** kdc\}lWg *****

UB		vLedMode;														//	\[h
UB		vLedTimeBase, vLedTime;											//	_PʁiƎwWj
UB		vLedPos;														//	kdc\ʒu

// ***************************************************************************
// *	e[u															 *
// ***************************************************************************

	//	***** VXe *****

const	UB		tSystemName[] = SYSTEM_NAME;							//	VXe̕
const	UB		tCopyright[] = COPYRIGHT;								//	쌠\
const	UB		tVersion[] = {											//	o[Wԍ
					VER1 | '0', VER2 | '0', '.', VER3 | '0', VER4 | '0', CODE_NUL
};

	//	***** kdc\ʒu *****

const	UH	tTimePos[10] = {											//	kdc̈ʒuiԒPʂ\ꍇA_Ci~bN̏ꍇŋʁj
	LED_DEV_A, LED_DEV_B, LED_DEV_C, LED_DEV_D, LED_DEV_E,				//	O`S	[
	LED_DEV_F, LED_DEV_G, LED_DEV_H, LED_DEV_I, LED_DEV_J,				//	S`X	E[
};

	//	***** kdc\F *****

const	UB	tColorPos[10] = {											//	\ʒuɑ΂F͌ŒƂ܂
	LED_DEV_RED,	LED_DEV_BLUE,	LED_DEV_PURPLE,	LED_DEV_GREEN,	LED_DEV_YELLOW,
	LED_DEV_WATER,	LED_DEV_WHITE,	LED_DEV_RED,	LED_DEV_BLUE,	LED_DEV_PURPLE,
};

// ***************************************************************************
// *	}N錾															 *
// ***************************************************************************


// ***************************************************************************
// *	vg^Cv錾													 *
// ***************************************************************************

	//	***** }lWg *****

int		main(void);
void	MngDynInit(void);
void	MngSwChange(UB Event);
void	MngDelay(UB Wait);

	//	***** foCX *****

void	DevCpuInit(void);
void	DevLedCtrl(UH Position, UB Color);
UB		DevGetSw(void);
void	DevTimCycInit(void);
void	DevTimCycEnaIpt(void);
BOOL	DevTimCycGetReq(void);

// ***************************************************************************
// *	{															 *
// ***************************************************************************

//	
//	
//
// 		}lWg
//
//	
//	
void	Mng______(void) {}												//	op֐

//============================================================================
//	C
//----------------------------------------------------------------------------
//	́F	
//	óF	ʁiOŒc@j
//----------------------------------------------------------------------------
//	lF	X^[gAbv[`̃Wv߂ŌĂяo܂B
//			{֐͖[vłAEo邱Ƃ͂܂B
//============================================================================
/*
	TvP͑ҋ@Ԃ̒ɃvOύXKvłB
	TvQł̓XCb`őҋ@Ԃ؂ւlɂ܂B

	ڈIɂ͂P̓_Ԃ2000us𒆐SƂđOT܂B

	XCb`ƑIlɑΉʒuLED_܂B
	XCb`͑Iʒu\AXCb`Itƕ]߂܂B

	ݒ蕪\500usƂ̂ŁA
	Eŏ 500usF 5000us( 5ms=200Hz)	c@[LED_
	Eő5000usF50000us(50ms= 20Hz)	c@E[LED_
ɂȂ܂B

	]p^[̓TvPɔׁA𔲂܂B

	`^Os߂ɔėpCu𗘗p܂B
*/

int		main(void)
{
	UB		SwEvent;													//	XCb`

	//	***** ͂߂ *****

	di();																//	荞݋֎~

	//	***** ݒ *****

	DevCpuInit();														//	botݒ
	DevTimCycInit();													//	^C}Jn			c@荞ݖgpA|[OŔf

	DrvSwChtInit((size_sw)DevGetSw());									//	`^O
	DrvSwActInit(DrvSwChtGetResult());									//	쎖۔F

	vLedTimeBase = 0;													//	_Pʂݒ
	vLedMode = 0;														//	\[hʏi]^Cvj
	MngDynInit();														//	kdc\ʒȕݒ

	//	***** ^p *****

	while (DevTimCycGetReq() == FALSE) ;								//	^C}̓oiPځj
	while (DevTimCycGetReq() == FALSE) ;								//	^C}̓oiQځj

	while (1) {															//	

		//	*****  *****

		if (DevTimCycGetReq()) {										//	^C}̃^CAEgH	c@TOOʂP

			//	***** XCb` *****

			DrvSwChtUpdate((size_sw)DevGetSw());						//	`^O
			SwEvent = DrvSwActUpdate((size_sw)DevGetSw());				//	쎖ۂ̍XVƎ擾

			MngSwChange(SwEvent);										//	XCb`쐧				c@XCb`̑ɉ

			//	***** _Ci~bN *****

			if (vLedMode == 0) {										//	ʏ\i]^CvjH		c@_Ci~bNs[h
				if (vLedTime > vLedTimeBase) {							//	_ԏIH
					vLedTime = 0;										//	ԃNA
					if ((++ vLedPos) >= 10) {	vLedPos = 0;	}		//	_ʒuXV
					DevLedCtrl(tTimePos[vLedPos], tColorPos[vLedPos]);	//	P̂kdc_				c@͈ʒuɑ΂锭F͌Œ
				}
				vLedTime ++;											//	_PʂXV
			}
			else {														//	Pʕ\
				;														//	ɕ\Ăkdc̏Ԃ͈ێ܂
			}
		}

		//	***** A *****

		;																//	ɖ
	}

	//	***** ܂ *****

	return(0);															//	ɂ͓BłȂꏊ
}

//============================================================================
//	kdc\ʒȕݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	_Ci~bN߂s߂̏ݒs܂B
//============================================================================
void	MngDynInit(void)
{
	vLedTime	= (UB)-1;												//	oߎԂőlɃZbgc@ŏ̐؂ւ𑁂邽
	vLedPos		= 10 - 1;												//	\ʒuE[		c@̃_Ci~bNō[ɒ
}

//============================================================================
//	XCb`쐧
//----------------------------------------------------------------------------
//	́F	쎖
//	óF	
//----------------------------------------------------------------------------
//	lF	XCb`̑쎖ۂɊÂԂ؂ւ܂B
//			IƃIt̃GbWoďs܂BԌpƍs
//			JԂs͂܂B
//============================================================================
void	MngSwChange(UB Event)
{
	switch (Event) {

		//	******************
		//	***** ̑ *****
		//	******************

		default:														//	̑

			;															//	ɖ

			break;

		//	****************
		//	***** I *****
		//	****************

		case SW_ACT_ON:													//	XCb`AItI

			if ((++ vLedTimeBase) >= 10) {	vLedTimeBase = 0;	}		//	ԒPʂXViO`Xj
			vLedMode = 1;												//	Iꂽl\	c@̏Ԃ̓_Ci~bN䂹AŒ\

			DevLedCtrl(tTimePos[vLedTimeBase], LED_DEV_RED);			//	ԐFőIʒu\ikdc͂Pj

			break;

		//	****************
		//	***** It *****
		//	****************

		case SW_ACT_SHORT:												//	XCb`AIIt	c@Pm
		case SW_ACT_END:												//	ij				c@钷I

			MngDynInit();												//	kdc\ʒȕݒ
			vLedMode = 0;												//	\[hʏi]^Cvj

			;															//	kdc̕\̓C̒ʏ폄̒ōs܂

			break;
	}
}

//============================================================================
//	POOʂPʂ̑ҋ@
//----------------------------------------------------------------------------
//	́F	ҋ@ԁiPOOʂPʁj
//	óF	
//----------------------------------------------------------------------------
//	lF	POOʂPʂőҋ@s܂B
//============================================================================

void	MngDelay(UB Wait)
{
	while (Wait --) {													//	񐔕̏
		__delay_us(100);												//	POOʂ̑ҋ@
	}
}

//	
//	
//
// 		荞ݐ
//
//	
//	
void	Ipt______(void) {}												//	op֐

//============================================================================
//	荞
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ʊ荞ݏłB
//============================================================================
void	interrupt	Ipt(void)
{
	;																	//	̃Tvł͕sv
}

//	
//	
//
// 		foCX
//
//	
//	
void	Dev______(void) {}												//	op֐

//============================================================================
//	botݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	botݒ肵܂B
//			Zbg̏l҂čŏ̐ݒōς܂Ă܂B
//============================================================================
void	DevCpuInit(void)
{
	//	***** ͂߂ *****

	di();																//	CIɂł荞݋֎~i֐I̋͍sȂj

	//	*****  *****

//					76543210
	OPTION_REG	= 0b01010111;											//	IvVWX^
																		//	b0:PS0		1	͂QTU			
																		//	b1:PS1		1	ij					
																		//	b2:PS2		1	ij					
																		//	b3:PSA		0	vXP[̓^C}O	
																		//	b4:T0SE		1	ilj
																		//	b5:T0CS		0	^C}ONbN͌U	
																		//	b6:INTEDG	1	ilj
																		//	b7:_RBPU	0	|[gavAbvL		

//					76543210
	OSCCON		= 0b01111000;											//	U䃌WX^
																		//	b0:SCS		0	ilj
																		//	b1:LTS		0	iǂݏopj
																		//	b2:HTS		0	iǂݏopj
																		//	b3:OSTS		1	iǂݏopj
																		//	b4:IRCF0	1	U͓Wlg		
																		//	b5:IRCF1	1	ij					
																		//	b6:IRCF2	1	ij					
																		//	b7:-----	0	-----

	//	***** |[g` *****

//					76543210
	vDevPortA 	= 0b00000000;											//	|[g`
	PORTA		= vDevPortA;											//		 		Port	Tris	Func
																		//	bit0:RA0	0		Out(0)	LED-a	kdcAC`i[j
	TRISA		= 0b00010000;											//	bit1:RA1	0		Out(0)	LED-b	kdcACa
																		//	bit2:RA2	0		Out(0)	LED-c	kdcACb
																		//	bit3:RA3	0		Out(0)	LED-d	kdcACc
																		//	bit4:RA4	0		In (1)	SW		XCb`AOvAbv
																		//	bit5:RA5	0		Out(0)	-----	
																		//	bit6:RA6	0		Out(0)	-----	
																		//	bit7:RA7	0		Out(0)	-----	

	ANSEL		= 0b00000000;											//	AiO͂𑍂ăfW^o͂ɐ؂ւi`mrV``mrOj

	//	***** |[ga *****

//					76543210
	vDevPortB	= 0b00000000;											//	|[ga
	PORTB		= vDevPortB;											//				Port	Tris	Func
																		//	bit0:RB0	0		Out(0)	LED-e	kdcACd
	TRISB		= 0b11000000;											//	bit1:RB1	0		Out(0)	LED-f	kdcACe
																		//	bit2:RB2	0		Out(0)	LED-g	kdcACf
																		//	bit3:RB3	0		Out(0)	LED-h	kdcACg
																		//	bit4:RB4	0		Out(0)	LED-i	kdcACh
																		//	bit5:RB5	0		Out(0)	LED-j	kdcACiiE[j
																		//	bit6:RB6	-		In(1)	\	vAbv͗LԂ̂͂
																		//	bit7:RB7	-		In(1)	\	vAbv͗LԂ̂͂

	ANSELH		= 0b00000000;											//	AiO͂𑍂ăfW^o͂ɐ؂ւi`mrPR``mrWj

	//	***** |[gb *****

//					76543210
	vDevPortC	= 0b00001110;											//	|[gb
	PORTC		= vDevPortC;											//				Port	Tris	Func
																		//	bit0:RC0	0		Out(0)	-----
	TRISC		= 0b11000000;											//	bit1:RC1	1		Out(0)	LED-G-K	kdcAC΃J\[h
																		//	bit2:RC2	1		Out(0)	LED-B-K	kdcACJ\[h
																		//	bit3:RC3	1		Out(0)	LED-R-K	kdcACԃJ\[h
																		//	bit4:RC4	0		Out(0)	-----
																		//	bit5:RC5	0		Out(0)	-----
																		//	bit6:RC6	-		In (1)	ʐMpɗ\AOvAbv
																		//	bit7:RC7	-		In (1)	ʐMpɗ\AOvAbv

	//	***** ܂ *****

	;																	//	ɂȂ
}

//============================================================================
//	wʒûkdc
//----------------------------------------------------------------------------
//	́F	ʒuAF
//	óF	
//----------------------------------------------------------------------------
//	lF	w肳ꂽʒûkdc_A͑ď܂B
//============================================================================
void	DevLedCtrl(UH Position, UB Color)
{
	//	***** kdc *****

	vDevPortC = (vDevPortC | LED_PORT_MASK_C);							//	eFkdcJ\[hgɂď
	PORTC = vDevPortC;													//	|[go͂łkdc

	//	***** ʒuI *****											//	PgɂȂ͂

	vDevPortA = (vDevPortA & ~LED_PORT_MASK_A)							//	``ĉSӏAm[hkɂāA
			  | ((UB)Position & LED_PORT_MASK_A);						//	``ĉSӏɑΉf[^
	PORTA = vDevPortA;													//	|[go͂ňʒuw

	vDevPortB = (vDevPortB & ~LED_PORT_MASK_B)							//	d`îUӏ̃Am[hkɂāA
			  | ((UB)(Position >> 4) & LED_PORT_MASK_B);				//	d`îUӏɑΉf[^
	PORTB = vDevPortB;													//	|[go͂ňʒuw

	//	***** kdc_ *****

	vDevPortC = (vDevPortC | LED_PORT_MASK_C) & Color;					//	\F̂݃J\[hkŏ
	PORTC = vDevPortC;													//	|[go͂łkdc_
}

//============================================================================
//	XCb`̏Ԏ擾
//----------------------------------------------------------------------------
//	́F	
//	óF	XCb`̏ԁiPFIAOFItj
//----------------------------------------------------------------------------
//	lF	XCb`̏Ԃ擾܂B
//============================================================================
UB		DevGetSw(void)
{
	if (RA4)	{	return(0);	}										//	XCb`ItԂ܂
	else		{	return(1);	}										//	XCb`IԂ܂
}

//============================================================================
//	^C}̋N							^C}Q		TOOʂ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	^C}ݒ肵N܂B
//			荞ݐݒA͕ʊ֐ɂčs܂B
//============================================================================
void	DevTimCycInit(void)
{
	//	***** ͂߂ *****

	TMR2ON = 0;															//	^C}~
	TMR2IE = 0;															//	^C}荞݋֎~
	TMR2IF = 0;															//	^C}荞ݗv

	//	***** ݒ *****

//				76543210
	T2CON	= 0b00000001;												//	^C}Q䃌WX^
																		//	b0	T2CKPS0		1	vXP[@FS
																		//	b1	T2CKPS1		0	ij
																		//	b2	TMR2ON		0	^C}Q~
																		//	b3	T2OUTPS0	0	|XgXP[FP
																		//	b4	T2OUTPS1	0	ij
																		//	b5	T2OUTPS2	0	ij
																		//	b6	T2OUTPS3	0	ij
																		//	b7	-----		0	

	PR2		= 250 - 1;													//	rΏۃZbg

/*
	Cycle = (((Fosc / 4) * Prescaler) * (Count + 1)) * Postscaler
		  = (( 8MHz / 4) *  4) * (249 + 1) * 1
		  = 0.5 * 4 * 250 * 1
		  = 2 * 250 = 500us
*/

	//	***** Jn *****

	TMR2	= 0;														//	^C}JE^NA
	TMR2ON	= 1;														//	^C}X^[g
}

//============================================================================
//	^C}̊荞݋					^C}Q
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	^C}ɂ銄荞݂܂B
//============================================================================
void	DevTimCycEnaIpt(void)
{
	TMR2IE = 1;															//	^C}荞݋
}

//============================================================================
//	^C}̊荞ݗvmFƃNA		^C}Q
//----------------------------------------------------------------------------
//	́F	
//	óF	荞ݗvisqtd^e`krdj
//----------------------------------------------------------------------------
//	lF	^C}̃^CAEgԂ܂B
//			荞݋֎~𔺂Ȃ̂ŁA荞ݏ̓Oŗpł܂B
//============================================================================
BOOL	DevTimCycGetReq(void)
{
	if (TMR2IF) {														//	荞ݗvH
		TMR2IF = 0;														//	v
		return(TRUE);													//	荞ݗvL܂
	}
	else {																//	荞ݗv܂
		return(FALSE);													//	荞ݗv܂
	}
}


// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2011 PaletteSoft LLC

